## secure-socket-funneling 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project("SSF")

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(CMAKE_CXX_STANDARD 14)

set(SSF_VERSION_MAJOR 3)
set(SSF_VERSION_MINOR 0)
set(SSF_VERSION_FIX 0)
set(SSF_VERSION_CIRCUIT 2)
set(SSF_VERSION_TRANSPORT 2)

set(SSF_VERSION "${SSF_VERSION_MAJOR}.${SSF_VERSION_MINOR}.${SSF_VERSION_FIX}")

# --- Options
include(CMakeDependentOption)
option(BUILD_UNIT_TESTS "Build SSF unit tests" OFF)
option(BUILD_NETWORK_UNIT_TESTS "Build SSF network layers unit tests" OFF)
option(DISABLE_TLS "Disable TLS" OFF)
option(USE_STATIC_LIBS "Link binaries statically against libraries" OFF)
CMAKE_DEPENDENT_OPTION(USE_STATIC_RUNTIME "Link statically against the C++ runtime libraries"
                       ON "USE_STATIC_LIBS" OFF)
option(DISABLE_RTTI "Disable C++ Runtime Type Information" OFF)
option(DISABLE_LOGS "Disable logs" OFF)
if (UNIX)
option(ENABLE_SYSLOG "Use syslog collector" ON)
endif (UNIX)

# --- Set default CMAKE_BUILD_TYPE if none is provided
# (Only relevant for single-configuration generators)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build type." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# --- Include CMake build system scripts
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# --- Include platform specific settings
if(CMAKE_COMPILER_IS_GNUCXX)
  if(USE_STATIC_RUNTIME)
    list(APPEND CMAKE_EXE_LINKER_FLAGS "-static-libstdc++ -static-libgcc")
    list(APPEND PLATFORM_LIBS libstdc++.a)
  endif(USE_STATIC_RUNTIME)
  if(DISABLE_RTTI)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
  endif(DISABLE_RTTI)
  if((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.7) AND (${CMAKE_SIZEOF_VOID_P} EQUAL "8"))
    list(APPEND PLATFORM_LIBS memcpy)
  endif()
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -ggdb")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2")
endif()
if(MSVC)
  if(USE_STATIC_RUNTIME)
    set(EXEC_FLAG "RUNTIME_STATIC")
    foreach(fl CMAKE_C_FLAGS CMAKE_CXX_FLAGS
               CMAKE_C_FLAGS_DEBUG CMAKE_CXX_FLAGS_DEBUG
               CMAKE_C_FLAGS_RELWITHDEBINFO CMAKE_CXX_FLAGS_RELWITHDEBINFO
               CMAKE_C_FLAGS_RELEASE CMAKE_CXX_FLAGS_RELEASE
               CMAKE_C_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_MINSIZEREL)
      string(REPLACE "/MD" "/MT" ${fl} "${${fl}}")
    endforeach()
  endif(USE_STATIC_RUNTIME)
  if(DISABLE_RTTI)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-")
  endif(DISABLE_RTTI)
  add_definitions(-D_WIN32_WINNT=0x0501)
  # Increase the number of sections that an object file can contain
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
  # Disable warning: 'identifier': decorated name length exceeded, name was truncated
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4503")
  # Disable warning C4996: security advice
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# --- Boost components
# Force linking boost statically on Visual Studio
if (MSVC)
  set(Boost_USE_STATIC_LIBS ON)
else()
  set(Boost_USE_STATIC_LIBS ${USE_STATIC_LIBS})
endif()
set(Boost_USE_STATIC_RUNTIME ${USE_STATIC_RUNTIME})
set(Boost_USE_MULTITHREADED ON)
find_package(Boost REQUIRED
             COMPONENTS system
                        date_time
                        filesystem
                        regex
                        chrono
                        thread)
add_library(boost INTERFACE)
target_include_directories(boost INTERFACE ${Boost_INCLUDE_DIRS})
target_link_libraries(boost INTERFACE ${Boost_LIBRARIES})
if(UNIX)
  target_link_libraries(boost INTERFACE pthread)
endif(UNIX)
target_compile_definitions(boost INTERFACE BOOST_EXCEPTION_DISABLE)
if (DISABLE_RTTI)
  target_compile_definitions(boost INTERFACE BOOST_NO_RTTI BOOST_NO_TYPEID)
endif(DISABLE_RTTI)

# --- OpenSSL components
set(OPENSSL_USE_STATIC_LIBS ${USE_STATIC_LIBS})
set(OPENSSL_MSVC_STATIC_RT ${USE_STATIC_RUNTIME})
find_package(OpenSSL REQUIRED)
add_library(ssl INTERFACE)
target_include_directories(ssl INTERFACE ${OPENSSL_INCLUDE_DIR})
target_link_libraries(ssl INTERFACE ${OPENSSL_LIBRARIES})
if(OPENSSL_USE_STATIC_LIBS AND MSVC_VERSION)
  include(CheckFunctionExists)
  CHECK_FUNCTION_EXISTS("_snprintf" HAVE_SNPRINTF)
  if(NOT HAVE_SNPRINTF)
    target_link_libraries(ssl INTERFACE legacy_stdio_definitions.lib)
  endif(NOT HAVE_SNPRINTF)
  CHECK_FUNCTION_EXISTS("__iob_func" HAVE_IOB_FUNC)
  if(NOT HAVE_IOB_FUNC)
    target_link_libraries(ssl INTERFACE iob_func)
  endif(NOT HAVE_IOB_FUNC)
endif()
message(STATUS "OpenSSL version: ${OPENSSL_VERSION}")

# --- http-parser components
add_subdirectory(third_party/http-parser)
add_subdirectory(third_party/msgpack)
add_subdirectory(third_party/spdlog)

# --- cxxopts
add_subdirectory(third_party/cxxopts EXCLUDE_FROM_ALL)

# --- Test certs
add_subdirectory(certs)

# --- Unit tests
if (BUILD_UNIT_TESTS OR BUILD_FRAMEWORK_UNIT_TESTS)
  include(unit_tests)
endif (BUILD_UNIT_TESTS OR BUILD_FRAMEWORK_UNIT_TESTS)

# -- Images
add_subdirectory(img)

# --- Add sources
add_subdirectory(src)

install(FILES ${TEST_CERT_FILES} DESTINATION bin/certs)
install(FILES ${TEST_CERT_TRUSTED_FILES} DESTINATION bin/certs/trusted)

# --- Print summary
message(STATUS "Build configuration:")
message(STATUS "  Version: ${SSF_VERSION}")
message(STATUS "  Unit Tests: ${BUILD_UNIT_TESTS}")
message(STATUS "  Network Unit Tests: ${BUILD_NETWORK_UNIT_TESTS}")
message(STATUS "  TLS Disabled: ${DISABLE_TLS}")
message(STATUS "  Static Libraries: ${USE_STATIC_LIBS} (Boost: ${Boost_USE_STATIC_LIBS}, OpenSSL: ${OPENSSL_USE_STATIC_LIBS})")
message(STATUS "  Static Runtime: ${USE_STATIC_RUNTIME} (Boost: ${Boost_USE_STATIC_RUNTIME}, OpenSSL: ${OPENSSL_MSVC_STATIC_RT})")
message(STATUS "  RTTI disabled: ${DISABLE_RTTI}")
message(STATUS "  Logs disabled: ${DISABLE_LOGS}")
if (UNIX)
message(STATUS "  Syslog collector enabled: ${ENABLE_SYSLOG}")
endif (UNIX)

=== certs/CMakeLists.txt ===
set(TEST_CERT_FILES ${CMAKE_CURRENT_SOURCE_DIR}/certificate.crt
  ${CMAKE_CURRENT_SOURCE_DIR}/private.key
  ${CMAKE_CURRENT_SOURCE_DIR}/server.crt
  ${CMAKE_CURRENT_SOURCE_DIR}/server.key
  ${CMAKE_CURRENT_SOURCE_DIR}/dh4096.pem PARENT_SCOPE)
set(TEST_CERT_TRUSTED_FILES ${CMAKE_CURRENT_SOURCE_DIR}/trusted/ca.crt PARENT_SCOPE)

function(copy_certs _tgt)
  add_custom_command(TARGET ${_tgt} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory $<TARGET_FILE_DIR:${_tgt}>/certs/trusted
    COMMAND ${CMAKE_COMMAND} -E copy ${TEST_CERT_FILES} $<TARGET_FILE_DIR:${_tgt}>/certs
    COMMAND ${CMAKE_COMMAND} -E copy ${TEST_CERT_TRUSTED_FILES} $<TARGET_FILE_DIR:${_tgt}>/certs/trusted)
endfunction(copy_certs)

include(file2string)

file2string(test_client_cert certificate.crt client_cert.h)
file2string(test_client_key private.key client_key.h)
file2string(test_server_cert server.crt server_cert.h)
file2string(test_server_key server.key server_key.h)
file2string(test_server_dh_param dh4096.pem server_dh_param.h)
file2string(test_ca_cert trusted/ca.crt ca_cert.h)

add_library(test_certs INTERFACE)
target_include_directories(test_certs INTERFACE ${CMAKE_CURRENT_BINARY_DIR})

=== img/CMakeLists.txt ===
set(ICON_RC ${CMAKE_CURRENT_SOURCE_DIR}/icon.rc PARENT_SCOPE)

=== src/CMakeLists.txt ===
# --- Project files declaration

configure_file(versions.h.in versions.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include(source_group_by_folder)

set(SSF_FRAMEWORK_FILES
  ${CMAKE_CURRENT_BINARY_DIR}/versions.h

  # fibers
  common/boost/fiber/basic_endpoint.hpp
  common/boost/fiber/basic_fiber_demux.hpp
  common/boost/fiber/basic_fiber_demux_service.hpp
  common/boost/fiber/basic_fiber_demux_service.ipp
  common/boost/fiber/datagram_fiber.hpp
  common/boost/fiber/datagram_fiber_service.hpp
  common/boost/fiber/detail/basic_fiber_demux_impl.hpp
  common/boost/fiber/detail/basic_fiber_impl.hpp
  common/boost/fiber/detail/fiber_buffer.hpp
  common/boost/fiber/detail/fiber_header.hpp
  common/boost/fiber/detail/fiber_id.hpp
  common/boost/fiber/detail/io_fiber_accept_op.hpp
  common/boost/fiber/detail/io_fiber_dgr_read_op.hpp
  common/boost/fiber/detail/io_fiber_read_op.hpp
  common/boost/fiber/detail/io_operation.hpp
  common/boost/fiber/detail/io_ssl_read_op.hpp
  common/boost/fiber/fiber_acceptor_service.hpp
  common/boost/fiber/stream_fiber.hpp
  common/boost/fiber/stream_fiber_service.hpp

  # config
  common/config/circuit.cpp
  common/config/circuit.h
  common/config/config.cpp
  common/config/config.h
  common/config/proxy.cpp
  common/config/proxy.h
  common/config/services.cpp
  common/config/services.h
  common/config/tls.cpp
  common/config/tls.h

  # crypto
  common/crypto/hash.h
  common/crypto/md5.h
  common/crypto/md5.cpp
  common/crypto/sha1.h
  common/crypto/sha1.cpp
  common/crypto/sha256.h
  common/crypto/sha256.cpp

  # errors
  common/error/error.cpp
  common/error/error.h

  # filesystem
  common/filesystem/path.h
  common/filesystem/path.cpp
  common/filesystem/filesystem.h
  common/filesystem/filesystem.cpp

  # utils
  common/utils/to_underlying.h

  # async engine
  core/async_engine.cpp
  core/async_engine.h

  # network
  core/network_protocol.cpp
  core/network_protocol.h

  # ssf protocol
  core/transport_virtual_layer_policies/init_packets/ssf_reply.cpp
  core/transport_virtual_layer_policies/init_packets/ssf_reply.h
  core/transport_virtual_layer_policies/init_packets/ssf_request.cpp
  core/transport_virtual_layer_policies/init_packets/ssf_request.h
  core/transport_virtual_layer_policies/transport_protocol_policy.h

  # commandline
  core/command_line/base.cpp
  core/command_line/base.h
  core/command_line/user_service_option_factory.h

  # commandline/copy
  core/command_line/copy/command_line.cpp
  core/command_line/copy/command_line.h

  # commandline/standard
  core/command_line/standard/command_line.cpp
  core/command_line/standard/command_line.h

  # factories
  core/factories/service_factory.h
  core/factory_manager/service_factory_manager.h
  core/service_manager/service_manager.h

  # microservices
  services/base_service.h
  services/base_service_config.cpp
  services/base_service_config.h
  services/service_port.h
  services/service_id.h

  # microservices/admin
  services/admin/admin.h
  services/admin/admin.ipp
  services/admin/admin_command.h
  services/admin/command_factory.h
  services/admin/requests/create_service_request.h
  services/admin/requests/service_status.h
  services/admin/requests/stop_service_request.h

  # microservices/copy
  services/copy/config.cpp
  services/copy/config.h

  services/copy/copy_client.h
  services/copy/copy_server.h
  services/copy/file_acceptor.h
  services/copy/file_sender.h

  services/copy/packet.h
  services/copy/packet.cpp
  services/copy/packet_helper.h

  # copy session
  services/copy/copy_context.h
  services/copy/copy_context.cpp
  services/copy/copy_session.h
  services/copy/error_code.h
  services/copy/error_code.cpp
  services/copy/i_copy_state.h

  services/copy/state/on_abort.h
  services/copy/state/on_abort.cpp

  # copy states receiver
  services/copy/state/receiver/abort_receiver_state.h
  services/copy/state/receiver/receive_file_state.h
  services/copy/state/receiver/send_abort_ack_state.h
  services/copy/state/receiver/send_eof_state.h
  services/copy/state/receiver/send_init_reply_state.h
  services/copy/state/receiver/send_integrity_check_reply_state.h
  services/copy/state/receiver/wait_close_state.h
  services/copy/state/receiver/wait_init_request_state.h
  services/copy/state/receiver/wait_integrity_check_request_state.h

  # copy states sender
  services/copy/state/sender/abort_sender_state.h
  services/copy/state/sender/close_state.h
  services/copy/state/sender/send_file_state.h
  services/copy/state/sender/send_init_request_state.h
  services/copy/state/sender/send_integrity_check_request_state.h
  services/copy/state/sender/wait_abort_ack_state.h
  services/copy/state/sender/wait_eof_state.h
  services/copy/state/sender/wait_init_reply_state.h
  services/copy/state/sender/wait_integrity_check_reply_state.h

  # copy packet
  services/copy/packet/check.h
  services/copy/packet/control.h
  services/copy/packet/data.h
  services/copy/packet/error_code.h
  services/copy/packet/error.h
  services/copy/packet/init.h

  # microservices/datagram
  services/datagram/datagram_link.h
  services/datagram/datagram_link_operator.h

  # microservices/datagram_to_fibers
  services/datagrams_to_fibers/config.cpp
  services/datagrams_to_fibers/config.h
  services/datagrams_to_fibers/datagrams_to_fibers.h
  services/datagrams_to_fibers/datagrams_to_fibers.ipp

  # microservices/fibers_to_datagrams
  services/fibers_to_datagrams/config.cpp
  services/fibers_to_datagrams/config.h
  services/fibers_to_datagrams/fibers_to_datagrams.h
  services/fibers_to_datagrams/fibers_to_datagrams.ipp

  # microservices/fibers_to_sockets
  services/fibers_to_sockets/config.cpp
  services/fibers_to_sockets/config.h
  services/fibers_to_sockets/fibers_to_sockets.h
  services/fibers_to_sockets/fibers_to_sockets.ipp
  services/fibers_to_sockets/session.h

  # microservices/process
  services/process/config.cpp
  services/process/config.h
  services/process/server.h
  services/process/server.ipp

  # microservices/sockets_to_fibers
  services/sockets_to_fibers/config.cpp
  services/sockets_to_fibers/config.h
  services/sockets_to_fibers/session.h
  services/sockets_to_fibers/sockets_to_fibers.h
  services/sockets_to_fibers/sockets_to_fibers.ipp

  # microservices/socks
  services/socks/config.cpp
  services/socks/config.h
  services/socks/socks_server.h
  services/socks/socks_server.ipp
  services/socks/socks_version.h
  services/socks/v4/session.h
  services/socks/v4/session.ipp
  services/socks/v5/session.h
  services/socks/v5/session.ipp

  # services
  services/user_services/base_user_service.h
  services/user_services/copy.h
  services/user_services/option_parser.cpp
  services/user_services/option_parser.h
  services/user_services/parameters.h
  services/user_services/port_forwarding.h
  services/user_services/shell.h
  services/user_services/remote_port_forwarding.h
  services/user_services/remote_shell.h
  services/user_services/remote_socks.h
  services/user_services/socks.h
  services/user_services/udp_port_forwarding.h
  services/user_services/remote_udp_port_forwarding.h
  services/user_service_factory.h

  # client
  core/client/client.cpp
  core/client/client.h
  core/client/client_helper.cpp
  core/client/client_helper.h
  core/client/session.h
  core/client/session.ipp
  core/client/status.h

  # server
  core/server/server.h
  core/server/server.ipp
)

# windows impl
if (WIN32)
  list(APPEND SSF_FRAMEWORK_FILES
    # microservices/process
    services/process/windows/session.h
    services/process/windows/session.ipp
  )
  list(APPEND PLATFORM_SPECIFIC_LIB_DEP "shlwapi.lib")
endif (WIN32)

# linux/unix impl
if (UNIX)
  list(APPEND SSF_FRAMEWORK_FILES
    # microservices/process
    services/process/posix/session.h
    services/process/posix/session.ipp
  )
endif (UNIX)

add_subdirectory(network)
add_subdirectory(compat)

add_library(ssf_framework STATIC "")
target_sources(ssf_framework PRIVATE ${SSF_FRAMEWORK_FILES})
target_include_directories(ssf_framework PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(ssf_framework PUBLIC boost ssl ${PLATFORM_LIBS} ssf_network cxxopts)
set_property(TARGET ssf_framework PROPERTY FOLDER Libraries)
source_group_by_folder(ssf_framework)

set(SSF_FRAMEWORK_DEFINITIONS "")

if(DISABLE_TLS)
  list(APPEND SSF_FRAMEWORK_DEFINITIONS TCP_ONLY_LINK)
else()
  list(APPEND SSF_FRAMEWORK_DEFINITIONS TLS_OVER_TCP_LINK)
endif(DISABLE_TLS)

if (DISABLE_RTTI)
  list(APPEND SSF_FRAMEWORK_DEFINITIONS CXXOPTS_NO_RTTI)
endif(DISABLE_RTTI)

target_compile_definitions(ssf_framework PUBLIC ${SSF_FRAMEWORK_DEFINITIONS})

add_subdirectory(client)
add_subdirectory(server)

if (BUILD_UNIT_TESTS)
  add_subdirectory(tests)
endif(BUILD_UNIT_TESTS)

=== src/client/CMakeLists.txt ===
add_executable(ssf ssf.cpp ${ICON_RC})
target_link_libraries(ssf ssf_framework)
set_property(TARGET ssf PROPERTY FOLDER "Executables")
copy_certs(ssf)

add_executable(ssfcp ssfcp.cpp ${ICON_RC})
target_link_libraries(ssfcp ssf_framework)
set_property(TARGET ssfcp PROPERTY FOLDER "Executables")
copy_certs(ssfcp)

install(TARGETS ssf ssfcp RUNTIME DESTINATION bin)

=== src/compat/CMakeLists.txt ===
add_library(iob_func STATIC EXCLUDE_FROM_ALL iob_func.cpp)
set_property(TARGET iob_func PROPERTY FOLDER "Compat")

add_library(memcpy STATIC EXCLUDE_FROM_ALL memcpy.cpp)
target_link_libraries(memcpy PUBLIC "-Wl,--wrap=memcpy")
set_property(TARGET memcpy PROPERTY FOLDER "Compat")

=== src/network/CMakeLists.txt ===
# specific platform lib
set(PLATFORM_LIBS "")

include(source_group_by_folder)

set(SSF_NETWORK_FILES
  # error
  ssf/error/error.h
  ssf/error/error.ipp

  # io
  ssf/io/accept_op.h
  ssf/io/buffers.h
  ssf/io/composed_op.h
  ssf/io/connect_op.h
  ssf/io/get_op.h
  ssf/io/handler_helpers.h
  ssf/io/op.h
  ssf/io/push_op.h
  ssf/io/read_op.h
  ssf/io/read_stream_op.h
  ssf/io/write_op.h

  # layer
  ssf/layer/accept_op.h
  ssf/layer/basic_empty_datagram.h
  ssf/layer/basic_empty_stream.h
  ssf/layer/basic_endpoint.h
  ssf/layer/basic_impl.h
  ssf/layer/basic_resolver.h
  ssf/layer/congestion/drop_tail_policy.h
  ssf/layer/connect_op.h
  ssf/layer/io_handler.h
  ssf/layer/parameters.cpp
  ssf/layer/parameters.h
  ssf/layer/protocol_attributes.h
  ssf/layer/receive_from_op.h

  # layer/crypto
  ssf/layer/cryptography/basic_crypto_stream.h
  ssf/layer/cryptography/crypto_stream_op.h
  ssf/layer/cryptography/tls/OpenSSL/helpers.cpp
  ssf/layer/cryptography/tls/OpenSSL/helpers.h
  ssf/layer/cryptography/tls/OpenSSL/impl.h

  # layer/datagram
  ssf/layer/datagram/basic_datagram.h
  ssf/layer/datagram/basic_flags.h
  ssf/layer/datagram/basic_header.h
  ssf/layer/datagram/basic_payload.h
  ssf/layer/datagram/empty_component.h

  # layer/data_link
  ssf/layer/data_link/basic_circuit_acceptor_service.h
  ssf/layer/data_link/basic_circuit_protocol.h
  ssf/layer/data_link/basic_circuit_socket_service.h
  ssf/layer/data_link/circuit_endpoint_context.h
  ssf/layer/data_link/circuit_helpers.cpp
  ssf/layer/data_link/circuit_helpers.h
  ssf/layer/data_link/circuit_op.h
  ssf/layer/data_link/helpers.h
  ssf/layer/data_link/simple_circuit_policy.h

  # layer/interface
  #ssf/layer/interface_layer/basic_interface.h
  #ssf/layer/interface_layer/basic_interface_manager.h
  #ssf/layer/interface_layer/basic_interface_protocol.cc
  #ssf/layer/interface_layer/basic_interface_protocol.h
  #ssf/layer/interface_layer/basic_interface_service.h
  #ssf/layer/interface_layer/generic_interface_socket.h
  #ssf/layer/interface_layer/interface_buffers.h
  #ssf/layer/interface_layer/specific_interface_socket.h

  # layer/multiplexing
  #ssf/layer/multiplexing/basic_demultiplexer.h
  #ssf/layer/multiplexing/basic_multiplexer.h
  #ssf/layer/multiplexing/basic_multiplexer_protocol.h
  #ssf/layer/multiplexing/basic_multiplexer_socket_service.h
  #ssf/layer/multiplexing/demultiplexer_manager.h
  #ssf/layer/multiplexing/multiplexer_manager.h
  #ssf/layer/multiplexing/port_multiplex_id.h
  #ssf/layer/multiplexing/protocol_and_port_multiplex_id.h
  #ssf/layer/multiplexing/protocol_multiplex_id.h

  # layer/network
  #ssf/layer/network/basic_network_protocol.h
  #ssf/layer/network/basic_network_raw_socket_service.h
  #ssf/layer/network/basic_network_socket_service.h
  #ssf/layer/network/network_id.h

  # layer/physical
  ssf/layer/physical/host.cpp
  ssf/layer/physical/host.h
  ssf/layer/physical/tcp.cpp
  ssf/layer/physical/tcp.h
  ssf/layer/physical/tcp_helpers.cpp
  ssf/layer/physical/tcp_helpers.h
  ssf/layer/physical/tlsotcp.h
  ssf/layer/physical/udp.h
  ssf/layer/physical/udp_helpers.cpp
  ssf/layer/physical/udp_helpers.h

  # layer/proxy
  ssf/layer/proxy/auth_strategy.cpp
  ssf/layer/proxy/auth_strategy.h
  ssf/layer/proxy/base64.cpp
  ssf/layer/proxy/base64.h
  ssf/layer/proxy/basic_auth_strategy.cpp
  ssf/layer/proxy/basic_auth_strategy.h
  ssf/layer/proxy/basic_proxy_acceptor_service.h
  ssf/layer/proxy/basic_proxy_protocol.h
  ssf/layer/proxy/basic_proxy_socket_service.h
  ssf/layer/proxy/connect_op.h
  ssf/layer/proxy/digest_auth_strategy.cpp
  ssf/layer/proxy/digest_auth_strategy.h
  ssf/layer/proxy/http_connect_op.h
  ssf/layer/proxy/http_request.cpp
  ssf/layer/proxy/http_request.h
  ssf/layer/proxy/http_response.cpp
  ssf/layer/proxy/http_response.h
  ssf/layer/proxy/http_response_builder.cpp
  ssf/layer/proxy/http_response_builder.h
  ssf/layer/proxy/http_session_initializer.cpp
  ssf/layer/proxy/http_session_initializer.h
  ssf/layer/proxy/negotiate_auth_strategy.cpp
  ssf/layer/proxy/negotiate_auth_strategy.h
  ssf/layer/proxy/ntlm_auth_strategy.cpp
  ssf/layer/proxy/ntlm_auth_strategy.h
  ssf/layer/proxy/platform_auth_impl.h
  ssf/layer/proxy/proxy_endpoint_context.cpp
  ssf/layer/proxy/proxy_endpoint_context.h
  ssf/layer/proxy/proxy_helpers.cpp
  ssf/layer/proxy/proxy_helpers.h
  ssf/layer/proxy/socks4_strategy.cpp
  ssf/layer/proxy/socks4_strategy.h
  ssf/layer/proxy/socks5_strategy.cpp
  ssf/layer/proxy/socks5_strategy.h
  ssf/layer/proxy/socks_connect_op.h
  ssf/layer/proxy/socks_session_initializer.cpp
  ssf/layer/proxy/socks_session_initializer.h
  ssf/layer/proxy/socks_strategy.h

  # layer/queue
  ssf/layer/queue/active_item.h
  ssf/layer/queue/async_queue.h
  ssf/layer/queue/async_queue_service.h
  ssf/layer/queue/commutator.h
  ssf/layer/queue/send_queued_datagram_socket.h
  ssf/layer/queue/tagged_item.h

  # layer/routing
  # ssf/layer/routing/basic_routed_protocol.h
  # ssf/layer/routing/basic_routed_socket_service.h
  # ssf/layer/routing/basic_router.h
  # ssf/layer/routing/basic_router_service.h
  # ssf/layer/routing/basic_routing_selector.h
  # ssf/layer/routing/basic_routing_table.h

  # log
  ssf/log/log.cpp
  ssf/log/log.h

  # network
  ssf/network/base_session.h
  ssf/network/manager.h
  ssf/network/object_io_helpers.h
  ssf/network/session_forwarder.h
  ssf/network/socket_link.h
  ssf/network/socks/socks.h
  ssf/network/socks/v4/reply.cpp
  ssf/network/socks/v4/reply.h
  ssf/network/socks/v4/request.cpp
  ssf/network/socks/v4/request.h
  ssf/network/socks/v5/reply.cpp
  ssf/network/socks/v5/reply.h
  ssf/network/socks/v5/reply_auth.cpp
  ssf/network/socks/v5/reply_auth.h
  ssf/network/socks/v5/request.cpp
  ssf/network/socks/v5/request.h
  ssf/network/socks/v5/request_auth.cpp
  ssf/network/socks/v5/request_auth.h
  ssf/network/socks/v5/types.h

  # router system
  # ssf/system/basic_interfaces_collection.h
  # ssf/system/specific_interfaces_collection.h
  # ssf/system/system_interfaces.cpp
  # ssf/system/system_interfaces.h
  # ssf/system/system_routers.cpp
  # ssf/system/system_routers.h

  # utils
  ssf/utils/cleaner.h
  ssf/utils/enum.h
  ssf/utils/map_helpers.h
)

set(SSF_NETWORK_DEFINITIONS "")

if (DISABLE_LOGS)
  list(APPEND SSF_NETWORK_DEFINITIONS "SSF_DISABLE_LOGS")
endif (DISABLE_LOGS)

if (ENABLE_SYSLOG)
  list(APPEND SSF_NETWORK_DEFINITIONS "SSF_ENABLE_SYSLOG")
endif()

if (WIN32)
  # windows impl
  list(APPEND PLATFORM_LIBS Secur32.lib)
  list(APPEND SSF_NETWORK_FILES
    # layer/proxy
    ssf/layer/proxy/windows/sspi_auth_impl.cpp
    ssf/layer/proxy/windows/sspi_auth_impl.h)
endif (WIN32)
if (UNIX)
  # linux/unix impl
  list(APPEND PLATFORM_LIBS dl)
  list(APPEND SSF_NETWORK_FILES
    # layer/proxy
    ssf/layer/proxy/unix/gssapi_auth_impl.cpp
    ssf/layer/proxy/unix/gssapi_auth_impl.h)
endif (UNIX)

add_library(ssf_network STATIC ${SSF_NETWORK_FILES})
target_include_directories(ssf_network PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(ssf_network PUBLIC boost ssl ${PLATFORM_LIBS} http_parser msgpack_c spdlog)
target_compile_definitions(ssf_network PUBLIC ${SSF_NETWORK_DEFINITIONS})
set_property(TARGET ssf_network PROPERTY FOLDER "Libraries")
source_group_by_folder(ssf_network)

if (BUILD_NETWORK_UNIT_TESTS)
  add_subdirectory(tests)
endif(BUILD_NETWORK_UNIT_TESTS)

=== src/server/CMakeLists.txt ===
add_executable(ssfd ssfd.cpp ${ICON_RC})
target_link_libraries(ssfd ssf_framework)
set_property(TARGET ssfd PROPERTY FOLDER "Executables")
copy_certs(ssfd)

install(TARGETS ssfd RUNTIME DESTINATION bin)

=== src/services/CMakeLists.txt ===
if(NOT DEP_BOOST_VERSION)
    set(DEP_BOOST_VERSION 1.55.0)
endif()

add_subdirectory(socks)
add_subdirectory(fibers_to_sockets)
add_subdirectory(sockets_to_fibers)

=== src/tests/CMakeLists.txt ===
add_library(tls_config_helper STATIC EXCLUDE_FROM_ALL
            tls_config_helper.h tls_config_helper.cpp)
target_link_libraries(tls_config_helper PUBLIC ssf_framework test_certs)

set_property(TARGET tls_config_helper PROPERTY FOLDER "Unit Tests")

add_subdirectory(commandline)
add_subdirectory(config)
add_subdirectory(filesystem)
add_subdirectory(network)
add_subdirectory(services)

=== third_party/http-parser/CMakeLists.txt ===
add_library(http_parser STATIC http-parser/http_parser.h http-parser/http_parser.c)
target_include_directories(http_parser PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
set_property(TARGET http_parser PROPERTY FOLDER "Third party")

=== third_party/msgpack/CMakeLists.txt ===
add_library(msgpack_c INTERFACE)
target_include_directories(msgpack_c INTERFACE
  ${CMAKE_CURRENT_SOURCE_DIR}/msgpack-c/include)

=== debian/changelog ===
secure-socket-funneling (3.0.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:09:52 +0200

secure-socket-funneling (3.0.0-0kali4) kali-dev; urgency=medium

  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file
  * Disable build of linux package, keep only the windows binaries

 -- Raphaël Hertzog <raphael@offensive-security.com>  Thu, 09 Apr 2020 19:14:48 +0200

secure-socket-funneling (3.0.0-0kali3) kali-rolling; urgency=medium

  * Try to upload directly in kali-rolling

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 13 Jun 2019 10:37:03 +0200

secure-socket-funneling (3.0.0-0kali2) kali-dev; urgency=medium

  * Switch install location

 -- Ben Wilson <g0tmi1k@kali.org>  Mon, 10 Jun 2019 21:19:37 +0100

secure-socket-funneling (3.0.0-0kali1) kali-dev; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Mon, 27 Nov 2017 14:22:15 +0100

secure-socket-funneling (2.2.0-0kali2) kali-dev; urgency=medium

  * Add a patch to try to fix the build on arm

 -- Sophie Brun <sophie@freexian.com>  Tue, 23 May 2017 09:35:26 +0200

secure-socket-funneling (2.2.0-0kali1) kali-dev; urgency=medium

  * Initial release (Closes: 3505)

 -- Sophie Brun <sophie@freexian.com>  Thu, 11 May 2017 14:42:54 +0200

=== debian/control ===
Source: secure-socket-funneling
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: debhelper (>= 10),
               unzip,
               cmake (>= 2.8.11),
#	       libboost1.62-all-dev,
               libkrb5-dev,
	       libssl1.0-dev,
               python
Standards-Version: 4.1.1
Homepage: https://github.com/securesocketfunneling/ssf

#Package: secure-socket-funneling
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Recommends: secure-socket-funneling-windows-binaries
#Description: Network tool and toolkit
# This package provides simple and efficient ways to forward data from multiple
# sockets (TCP or UDP) through a single secure TLS link to a remote computer.
# .
# SSF Features:
#  * Local and remote TCP port forwarding
#  * Local and remote UDP port forwarding
#  * Local and remote SOCKS server
#  * Local and remote shell through socket
#  * Native relay protocol
#  * TLS connection with strongest cipher-suites

Package: secure-socket-funneling-windows-binaries
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SSF - windows binaries
 This package provides simple and efficient ways to forward data from multiple
 sockets (TCP or UDP) through a single secure TLS link to a remote computer.
 .
 This package provides the 32 bits and 64 bits windows binaries of Secure Socket
 Funneling.
 .
 SSF Features:
  * Local and remote TCP port forwarding
  * Local and remote UDP port forwarding
  * Local and remote SOCKS server
  * Local and remote shell through socket
  * Native relay protocol
  * TLS connection with strongest cipher-suites

=== debian/rules ===
#!/usr/bin/make -f

INSTALL_BIN_PATH=debian/ssf/usr/bin
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ -S none

override_dh_auto_configure:
	cp -r debian/cxxopts third_party/
	cp -r debian/googletest third_party/
	cp -r debian/http-parser third_party/http-parser
	cp -r debian/msgpack-c third_party/msgpack
	cp -r debian/spdlog third_party/spdlog
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DSSF_SECURITY:STRING="STANDARD" ../

override_dh_auto_test:
# drop the tests. can't get them build correctly

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%secure-socket-funneling-$1.tar.gz%" \
   https://github.com/securesocketfunneling/ssf/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
